"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExperimentServiceTypes = exports.DeviceServiceTypes = exports.AuthenticationServiceTypes = void 0;
exports.isSuccessResponse = isSuccessResponse;
exports.isErrorResponse = isErrorResponse;
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const basicValidation_js_1 = require("./basicValidation.js");
/**
 * @internal
 */
function isSuccessResponse(response) {
    return response.status < 400;
}
/**
 * @internal
 */
function isErrorResponse(response) {
    return response.status >= 400;
}
/**
 * Namespace containing the types for the Authentication Service.
 */
var AuthenticationServiceTypes;
(function (AuthenticationServiceTypes) {
    function isUser(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.AuthenticationServiceBasicValidation.validateUserRequest(obj);
            case "response":
                return basicValidation_js_1.AuthenticationServiceBasicValidation.validateUserResponse(obj);
            default:
                return basicValidation_js_1.AuthenticationServiceBasicValidation.validateUser(obj);
        }
    }
    AuthenticationServiceTypes.isUser = isUser;
})(AuthenticationServiceTypes || (exports.AuthenticationServiceTypes = AuthenticationServiceTypes = {}));
/**
 * Namespace containing the types for the Device Service.
 */
var DeviceServiceTypes;
(function (DeviceServiceTypes) {
    function isDeviceOverview(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceOverviewRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceOverviewResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceOverview(obj);
        }
    }
    DeviceServiceTypes.isDeviceOverview = isDeviceOverview;
    function isInstantiableCloudDevice(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateInstantiableCloudDeviceRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateInstantiableCloudDeviceResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateInstantiableCloudDevice(obj);
        }
    }
    DeviceServiceTypes.isInstantiableCloudDevice = isInstantiableCloudDevice;
    function isConcreteDevice(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateConcreteDeviceRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateConcreteDeviceResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateConcreteDevice(obj);
        }
    }
    DeviceServiceTypes.isConcreteDevice = isConcreteDevice;
    function isInstantiableBrowserDevice(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateInstantiableBrowserDeviceRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateInstantiableBrowserDeviceResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateInstantiableBrowserDevice(obj);
        }
    }
    DeviceServiceTypes.isInstantiableBrowserDevice = isInstantiableBrowserDevice;
    function isDeviceGroup(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceGroupRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceGroupResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceGroup(obj);
        }
    }
    DeviceServiceTypes.isDeviceGroup = isDeviceGroup;
    function isDevice(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDevice(obj);
        }
    }
    DeviceServiceTypes.isDevice = isDevice;
    function isCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCallbackResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCallback(obj);
        }
    }
    DeviceServiceTypes.isCallback = isCallback;
    function isEventCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateEventCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateEventCallbackResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateEventCallback(obj);
        }
    }
    DeviceServiceTypes.isEventCallback = isEventCallback;
    function isDeviceChangedEventCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceChangedEventCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceChangedEventCallbackResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateDeviceChangedEventCallback(obj);
        }
    }
    DeviceServiceTypes.isDeviceChangedEventCallback = isDeviceChangedEventCallback;
    function isMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateMessage(obj);
        }
    }
    DeviceServiceTypes.isMessage = isMessage;
    function isCommandMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCommandMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCommandMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCommandMessage(obj);
        }
    }
    DeviceServiceTypes.isCommandMessage = isCommandMessage;
    function isCreatePeerconnectionMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCreatePeerconnectionMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCreatePeerconnectionMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateCreatePeerconnectionMessage(obj);
        }
    }
    DeviceServiceTypes.isCreatePeerconnectionMessage = isCreatePeerconnectionMessage;
    function isClosePeerconnectionMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateClosePeerconnectionMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateClosePeerconnectionMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateClosePeerconnectionMessage(obj);
        }
    }
    DeviceServiceTypes.isClosePeerconnectionMessage = isClosePeerconnectionMessage;
    function isSignalingMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateSignalingMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateSignalingMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateSignalingMessage(obj);
        }
    }
    DeviceServiceTypes.isSignalingMessage = isSignalingMessage;
    function isConfigurationMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateConfigurationMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateConfigurationMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateConfigurationMessage(obj);
        }
    }
    DeviceServiceTypes.isConfigurationMessage = isConfigurationMessage;
    function isExperimentStatusChangedMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateExperimentStatusChangedMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateExperimentStatusChangedMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateExperimentStatusChangedMessage(obj);
        }
    }
    DeviceServiceTypes.isExperimentStatusChangedMessage = isExperimentStatusChangedMessage;
    function isLoggingMessage(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateLoggingMessageRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validateLoggingMessageResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validateLoggingMessage(obj);
        }
    }
    DeviceServiceTypes.isLoggingMessage = isLoggingMessage;
    function isPeerconnection(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnection(obj);
        }
    }
    DeviceServiceTypes.isPeerconnection = isPeerconnection;
    function isPeerconnectionClosedEventCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionClosedEventCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionClosedEventCallbackResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionClosedEventCallback(obj);
        }
    }
    DeviceServiceTypes.isPeerconnectionClosedEventCallback = isPeerconnectionClosedEventCallback;
    function isPeerconnectionStatusChangedEventCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionStatusChangedEventCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionStatusChangedEventCallbackResponse(obj);
            default:
                return basicValidation_js_1.DeviceServiceBasicValidation.validatePeerconnectionStatusChangedEventCallback(obj);
        }
    }
    DeviceServiceTypes.isPeerconnectionStatusChangedEventCallback = isPeerconnectionStatusChangedEventCallback;
})(DeviceServiceTypes || (exports.DeviceServiceTypes = DeviceServiceTypes = {}));
/**
 * Namespace containing the types for the Experiment Service.
 */
var ExperimentServiceTypes;
(function (ExperimentServiceTypes) {
    function isCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateCallbackResponse(obj);
            default:
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateCallback(obj);
        }
    }
    ExperimentServiceTypes.isCallback = isCallback;
    function isEventCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateEventCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateEventCallbackResponse(obj);
            default:
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateEventCallback(obj);
        }
    }
    ExperimentServiceTypes.isEventCallback = isEventCallback;
    function isExperimentChangedEventCallback(obj, type = "all") {
        switch (type) {
            case "request":
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateExperimentChangedEventCallbackRequest(obj);
            case "response":
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateExperimentChangedEventCallbackResponse(obj);
            default:
                return basicValidation_js_1.ExperimentServiceBasicValidation.validateExperimentChangedEventCallback(obj);
        }
    }
    ExperimentServiceTypes.isExperimentChangedEventCallback = isExperimentChangedEventCallback;
})(ExperimentServiceTypes || (exports.ExperimentServiceTypes = ExperimentServiceTypes = {}));
//# sourceMappingURL=types.js.map