/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
import { Require, SuccessResponse, ErrorResponse, AuthenticationServiceTypes, DeviceServiceTypes, ExperimentServiceTypes, FederationServiceTypes, BookingServiceTypes, LTIServiceTypes } from "./types.js";
/**
 * Namespace containing the signatures for the Authentication Service.
 */
export declare namespace AuthenticationServiceSignatures {
    /**
     * Typing for the body of the request made by login()
     * @category login()
     */
    type LoginBody = AuthenticationServiceTypes.Credentials<"request"> & {
        /**
         * Authentication method.
         */
        method?: AuthenticationServiceTypes.AuthMethod<"request">;
        [k: string]: unknown;
    };
    /**
     * Typing for all possible responses to the request made by login()
     * @category login()
     */
    type LoginResponse = LoginSuccessResponse | LoginErrorResponse;
    /**
     * Typing for all successful responses to the request made by login()
     * @category login()
     */
    type LoginSuccessResponse = LoginResponse201;
    /**
     * Typing for all error responses to the request made by login()
     * @category login()
     */
    type LoginErrorResponse = LoginResponse400 | LoginResponse401 | LoginResponse403 | LoginResponse404 | LoginResponse500;
    /**
     * Typing for a response with status 201 to the request made by login()
     * @category login()
     */
    interface LoginResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 400 to the request made by login()
     * @category login()
     */
    interface LoginResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by login()
     * @category login()
     */
    interface LoginResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by login()
     * @category login()
     */
    interface LoginResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by login()
     * @category login()
     */
    interface LoginResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by login()
     * @category login()
     */
    interface LoginResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the body of the request made by logout()
     * @category logout()
     */
    type LogoutBody = {
        /**
         * The token to be invalidated.
         */
        token?: string;
        [k: string]: unknown;
    };
    /**
     * Typing for all possible responses to the request made by logout()
     * @category logout()
     */
    type LogoutResponse = LogoutSuccessResponse | LogoutErrorResponse;
    /**
     * Typing for all successful responses to the request made by logout()
     * @category logout()
     */
    type LogoutSuccessResponse = LogoutResponse204;
    /**
     * Typing for all error responses to the request made by logout()
     * @category logout()
     */
    type LogoutErrorResponse = LogoutResponse400 | LogoutResponse401 | LogoutResponse403 | LogoutResponse404 | LogoutResponse500;
    /**
     * Typing for a response with status 204 to the request made by logout()
     * @category logout()
     */
    interface LogoutResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by logout()
     * @category logout()
     */
    interface LogoutResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by logout()
     * @category logout()
     */
    interface LogoutResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by logout()
     * @category logout()
     */
    interface LogoutResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by logout()
     * @category logout()
     */
    interface LogoutResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by logout()
     * @category logout()
     */
    interface LogoutResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by listUsers()
     * @category listUsers()
     */
    type ListUsersParameters = {
        "username"?: string;
    };
    /**
     * Typing for all possible responses to the request made by listUsers()
     * @category listUsers()
     */
    type ListUsersResponse = ListUsersSuccessResponse | ListUsersErrorResponse;
    /**
     * Typing for all successful responses to the request made by listUsers()
     * @category listUsers()
     */
    type ListUsersSuccessResponse = ListUsersResponse200;
    /**
     * Typing for all error responses to the request made by listUsers()
     * @category listUsers()
     */
    type ListUsersErrorResponse = ListUsersResponse400 | ListUsersResponse401 | ListUsersResponse403 | ListUsersResponse404 | ListUsersResponse500;
    /**
     * Typing for a response with status 200 to the request made by listUsers()
     * @category listUsers()
     */
    interface ListUsersResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (Require<AuthenticationServiceTypes.User<"response">, "url" | "id" | "username">)[];
    }
    /**
     * Typing for a response with status 400 to the request made by listUsers()
     * @category listUsers()
     */
    interface ListUsersResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by listUsers()
     * @category listUsers()
     */
    interface ListUsersResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by listUsers()
     * @category listUsers()
     */
    interface ListUsersResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by listUsers()
     * @category listUsers()
     */
    interface ListUsersResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by listUsers()
     * @category listUsers()
     */
    interface ListUsersResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the body of the request made by createUser()
     * @category createUser()
     */
    type CreateUserBody = Require<AuthenticationServiceTypes.User<"request">, "username" | "password">;
    /**
     * Typing for all possible responses to the request made by createUser()
     * @category createUser()
     */
    type CreateUserResponse = CreateUserSuccessResponse | CreateUserErrorResponse;
    /**
     * Typing for all successful responses to the request made by createUser()
     * @category createUser()
     */
    type CreateUserSuccessResponse = CreateUserResponse201;
    /**
     * Typing for all error responses to the request made by createUser()
     * @category createUser()
     */
    type CreateUserErrorResponse = CreateUserResponse400 | CreateUserResponse401 | CreateUserResponse403 | CreateUserResponse404 | CreateUserResponse500;
    /**
     * Typing for a response with status 201 to the request made by createUser()
     * @category createUser()
     */
    interface CreateUserResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: Require<AuthenticationServiceTypes.User<"response">, "url" | "id" | "username">;
    }
    /**
     * Typing for a response with status 400 to the request made by createUser()
     * @category createUser()
     */
    interface CreateUserResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by createUser()
     * @category createUser()
     */
    interface CreateUserResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by createUser()
     * @category createUser()
     */
    interface CreateUserResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by createUser()
     * @category createUser()
     */
    interface CreateUserResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by createUser()
     * @category createUser()
     */
    interface CreateUserResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getUser()
     * @category getUser()
     */
    type GetUserParameters = {
        "user_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getUser()
     * @category getUser()
     */
    type GetUserResponse = GetUserSuccessResponse | GetUserErrorResponse;
    /**
     * Typing for all successful responses to the request made by getUser()
     * @category getUser()
     */
    type GetUserSuccessResponse = GetUserResponse200;
    /**
     * Typing for all error responses to the request made by getUser()
     * @category getUser()
     */
    type GetUserErrorResponse = GetUserResponse400 | GetUserResponse401 | GetUserResponse403 | GetUserResponse404 | GetUserResponse500;
    /**
     * Typing for a response with status 200 to the request made by getUser()
     * @category getUser()
     */
    interface GetUserResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: Require<AuthenticationServiceTypes.User<"response">, "url" | "id" | "username">;
    }
    /**
     * Typing for a response with status 400 to the request made by getUser()
     * @category getUser()
     */
    interface GetUserResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getUser()
     * @category getUser()
     */
    interface GetUserResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getUser()
     * @category getUser()
     */
    interface GetUserResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getUser()
     * @category getUser()
     */
    interface GetUserResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getUser()
     * @category getUser()
     */
    interface GetUserResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateUser()
     * @category updateUser()
     */
    type UpdateUserParameters = {
        "user_id": string;
    };
    /**
     * Typing for the body of the request made by updateUser()
     * @category updateUser()
     */
    type UpdateUserBody = AuthenticationServiceTypes.User<"request">;
    /**
     * Typing for all possible responses to the request made by updateUser()
     * @category updateUser()
     */
    type UpdateUserResponse = UpdateUserSuccessResponse | UpdateUserErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateUser()
     * @category updateUser()
     */
    type UpdateUserSuccessResponse = UpdateUserResponse200;
    /**
     * Typing for all error responses to the request made by updateUser()
     * @category updateUser()
     */
    type UpdateUserErrorResponse = UpdateUserResponse400 | UpdateUserResponse401 | UpdateUserResponse403 | UpdateUserResponse404 | UpdateUserResponse500;
    /**
     * Typing for a response with status 200 to the request made by updateUser()
     * @category updateUser()
     */
    interface UpdateUserResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: Require<AuthenticationServiceTypes.User<"response">, "url" | "id" | "username">;
    }
    /**
     * Typing for a response with status 400 to the request made by updateUser()
     * @category updateUser()
     */
    interface UpdateUserResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updateUser()
     * @category updateUser()
     */
    interface UpdateUserResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by updateUser()
     * @category updateUser()
     */
    interface UpdateUserResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by updateUser()
     * @category updateUser()
     */
    interface UpdateUserResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by updateUser()
     * @category updateUser()
     */
    interface UpdateUserResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteUser()
     * @category deleteUser()
     */
    type DeleteUserParameters = {
        "user_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteUser()
     * @category deleteUser()
     */
    type DeleteUserResponse = DeleteUserSuccessResponse | DeleteUserErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteUser()
     * @category deleteUser()
     */
    type DeleteUserSuccessResponse = DeleteUserResponse204;
    /**
     * Typing for all error responses to the request made by deleteUser()
     * @category deleteUser()
     */
    type DeleteUserErrorResponse = DeleteUserResponse400 | DeleteUserResponse401 | DeleteUserResponse403 | DeleteUserResponse404 | DeleteUserResponse500;
    /**
     * Typing for a response with status 204 to the request made by deleteUser()
     * @category deleteUser()
     */
    interface DeleteUserResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by deleteUser()
     * @category deleteUser()
     */
    interface DeleteUserResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteUser()
     * @category deleteUser()
     */
    interface DeleteUserResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deleteUser()
     * @category deleteUser()
     */
    interface DeleteUserResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deleteUser()
     * @category deleteUser()
     */
    interface DeleteUserResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deleteUser()
     * @category deleteUser()
     */
    interface DeleteUserResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for all possible responses to the request made by getIdentity()
     * @category getIdentity()
     */
    type GetIdentityResponse = GetIdentitySuccessResponse | GetIdentityErrorResponse;
    /**
     * Typing for all successful responses to the request made by getIdentity()
     * @category getIdentity()
     */
    type GetIdentitySuccessResponse = GetIdentityResponse200;
    /**
     * Typing for all error responses to the request made by getIdentity()
     * @category getIdentity()
     */
    type GetIdentityErrorResponse = GetIdentityResponse400 | GetIdentityResponse401 | GetIdentityResponse403 | GetIdentityResponse404 | GetIdentityResponse500;
    /**
     * Typing for a response with status 200 to the request made by getIdentity()
     * @category getIdentity()
     */
    interface GetIdentityResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: AuthenticationServiceTypes.User<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by getIdentity()
     * @category getIdentity()
     */
    interface GetIdentityResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getIdentity()
     * @category getIdentity()
     */
    interface GetIdentityResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getIdentity()
     * @category getIdentity()
     */
    interface GetIdentityResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getIdentity()
     * @category getIdentity()
     */
    interface GetIdentityResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getIdentity()
     * @category getIdentity()
     */
    interface GetIdentityResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the body of the request made by updateIdentity()
     * @category updateIdentity()
     */
    type UpdateIdentityBody = AuthenticationServiceTypes.User<"request"> | undefined;
    /**
     * Typing for all possible responses to the request made by updateIdentity()
     * @category updateIdentity()
     */
    type UpdateIdentityResponse = UpdateIdentitySuccessResponse | UpdateIdentityErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateIdentity()
     * @category updateIdentity()
     */
    type UpdateIdentitySuccessResponse = UpdateIdentityResponse200;
    /**
     * Typing for all error responses to the request made by updateIdentity()
     * @category updateIdentity()
     */
    type UpdateIdentityErrorResponse = UpdateIdentityResponse400 | UpdateIdentityResponse401 | UpdateIdentityResponse403 | UpdateIdentityResponse404 | UpdateIdentityResponse500;
    /**
     * Typing for a response with status 200 to the request made by updateIdentity()
     * @category updateIdentity()
     */
    interface UpdateIdentityResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: AuthenticationServiceTypes.User<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by updateIdentity()
     * @category updateIdentity()
     */
    interface UpdateIdentityResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updateIdentity()
     * @category updateIdentity()
     */
    interface UpdateIdentityResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by updateIdentity()
     * @category updateIdentity()
     */
    interface UpdateIdentityResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by updateIdentity()
     * @category updateIdentity()
     */
    interface UpdateIdentityResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by updateIdentity()
     * @category updateIdentity()
     */
    interface UpdateIdentityResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the body of the request made by createToken()
     * @category createToken()
     */
    type CreateTokenBody = {
        /**
         * Url or uuid of the user that will be used to create the token.
         */
        user: string;
        /**
         * The claims that will be added to the token. If left empty, the token will have the full scope of the user.
         *
         */
        claims?: {
            [k: string]: unknown;
        };
        [k: string]: unknown;
    } | {
        /**
         * Url or uuid of the user that will be used to create the token.
         */
        username: string;
        /**
         * The claims that will be added to the token. If left empty, the token will have the full scope of the user.
         *
         */
        claims?: {
            [k: string]: unknown;
        };
        [k: string]: unknown;
    };
    /**
     * Typing for all possible responses to the request made by createToken()
     * @category createToken()
     */
    type CreateTokenResponse = CreateTokenSuccessResponse;
    /**
     * Typing for all successful responses to the request made by createToken()
     * @category createToken()
     */
    type CreateTokenSuccessResponse = CreateTokenResponse201;
    /**
     * Typing for a response with status 201 to the request made by createToken()
     * @category createToken()
     */
    interface CreateTokenResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
}
/**
 * Namespace containing the signatures for the Device Service.
 */
export declare namespace DeviceServiceSignatures {
    /**
     * Typing for all possible responses to the request made by listDevices()
     * @category listDevices()
     */
    type ListDevicesResponse = ListDevicesSuccessResponse | ListDevicesErrorResponse;
    /**
     * Typing for all successful responses to the request made by listDevices()
     * @category listDevices()
     */
    type ListDevicesSuccessResponse = ListDevicesResponse200;
    /**
     * Typing for all error responses to the request made by listDevices()
     * @category listDevices()
     */
    type ListDevicesErrorResponse = ListDevicesResponse400 | ListDevicesResponse401 | ListDevicesResponse403 | ListDevicesResponse404 | ListDevicesResponse500;
    /**
     * Typing for a response with status 200 to the request made by listDevices()
     * @category listDevices()
     */
    interface ListDevicesResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (DeviceServiceTypes.DeviceOverview<"response">)[];
    }
    /**
     * Typing for a response with status 400 to the request made by listDevices()
     * @category listDevices()
     */
    interface ListDevicesResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by listDevices()
     * @category listDevices()
     */
    interface ListDevicesResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by listDevices()
     * @category listDevices()
     */
    interface ListDevicesResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by listDevices()
     * @category listDevices()
     */
    interface ListDevicesResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by listDevices()
     * @category listDevices()
     */
    interface ListDevicesResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by createDevice()
     * @category createDevice()
     */
    type CreateDeviceParameters = {
        "changedUrl"?: string;
    };
    /**
     * Typing for the body of the request made by createDevice()
     * @category createDevice()
     */
    type CreateDeviceBody = DeviceServiceTypes.Device<"request">;
    /**
     * Typing for all possible responses to the request made by createDevice()
     * @category createDevice()
     */
    type CreateDeviceResponse = CreateDeviceSuccessResponse | CreateDeviceErrorResponse;
    /**
     * Typing for all successful responses to the request made by createDevice()
     * @category createDevice()
     */
    type CreateDeviceSuccessResponse = CreateDeviceResponse201;
    /**
     * Typing for all error responses to the request made by createDevice()
     * @category createDevice()
     */
    type CreateDeviceErrorResponse = CreateDeviceResponse400 | CreateDeviceResponse401 | CreateDeviceResponse403 | CreateDeviceResponse404 | CreateDeviceResponse500;
    /**
     * Typing for a response with status 201 to the request made by createDevice()
     * @category createDevice()
     */
    interface CreateDeviceResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Device<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by createDevice()
     * @category createDevice()
     */
    interface CreateDeviceResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by createDevice()
     * @category createDevice()
     */
    interface CreateDeviceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by createDevice()
     * @category createDevice()
     */
    interface CreateDeviceResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by createDevice()
     * @category createDevice()
     */
    interface CreateDeviceResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by createDevice()
     * @category createDevice()
     */
    interface CreateDeviceResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getDevice()
     * @category getDevice()
     */
    type GetDeviceParameters = {
        "device_id": string;
        "flat_group"?: boolean;
    };
    /**
     * Typing for all possible responses to the request made by getDevice()
     * @category getDevice()
     */
    type GetDeviceResponse = GetDeviceSuccessResponse | GetDeviceErrorResponse;
    /**
     * Typing for all successful responses to the request made by getDevice()
     * @category getDevice()
     */
    type GetDeviceSuccessResponse = GetDeviceResponse200;
    /**
     * Typing for all error responses to the request made by getDevice()
     * @category getDevice()
     */
    type GetDeviceErrorResponse = GetDeviceResponse400 | GetDeviceResponse401 | GetDeviceResponse403 | GetDeviceResponse404 | GetDeviceResponse500;
    /**
     * Typing for a response with status 200 to the request made by getDevice()
     * @category getDevice()
     */
    interface GetDeviceResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Device<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by getDevice()
     * @category getDevice()
     */
    interface GetDeviceResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getDevice()
     * @category getDevice()
     */
    interface GetDeviceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getDevice()
     * @category getDevice()
     */
    interface GetDeviceResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getDevice()
     * @category getDevice()
     */
    interface GetDeviceResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getDevice()
     * @category getDevice()
     */
    interface GetDeviceResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateDevice()
     * @category updateDevice()
     */
    type UpdateDeviceParameters = {
        "device_id": string;
        "changedUrl"?: string;
    };
    /**
     * Typing for the body of the request made by updateDevice()
     * @category updateDevice()
     */
    type UpdateDeviceBody = DeviceServiceTypes.DeviceUpdate<"request"> | undefined;
    /**
     * Typing for all possible responses to the request made by updateDevice()
     * @category updateDevice()
     */
    type UpdateDeviceResponse = UpdateDeviceSuccessResponse | UpdateDeviceErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateDevice()
     * @category updateDevice()
     */
    type UpdateDeviceSuccessResponse = UpdateDeviceResponse200;
    /**
     * Typing for all error responses to the request made by updateDevice()
     * @category updateDevice()
     */
    type UpdateDeviceErrorResponse = UpdateDeviceResponse400 | UpdateDeviceResponse401 | UpdateDeviceResponse403 | UpdateDeviceResponse404 | UpdateDeviceResponse500;
    /**
     * Typing for a response with status 200 to the request made by updateDevice()
     * @category updateDevice()
     */
    interface UpdateDeviceResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Device<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by updateDevice()
     * @category updateDevice()
     */
    interface UpdateDeviceResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updateDevice()
     * @category updateDevice()
     */
    interface UpdateDeviceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by updateDevice()
     * @category updateDevice()
     */
    interface UpdateDeviceResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by updateDevice()
     * @category updateDevice()
     */
    interface UpdateDeviceResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by updateDevice()
     * @category updateDevice()
     */
    interface UpdateDeviceResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteDevice()
     * @category deleteDevice()
     */
    type DeleteDeviceParameters = {
        "device_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteDevice()
     * @category deleteDevice()
     */
    type DeleteDeviceResponse = DeleteDeviceSuccessResponse | DeleteDeviceErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteDevice()
     * @category deleteDevice()
     */
    type DeleteDeviceSuccessResponse = DeleteDeviceResponse204;
    /**
     * Typing for all error responses to the request made by deleteDevice()
     * @category deleteDevice()
     */
    type DeleteDeviceErrorResponse = DeleteDeviceResponse400 | DeleteDeviceResponse401 | DeleteDeviceResponse403 | DeleteDeviceResponse404 | DeleteDeviceResponse500;
    /**
     * Typing for a response with status 204 to the request made by deleteDevice()
     * @category deleteDevice()
     */
    interface DeleteDeviceResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by deleteDevice()
     * @category deleteDevice()
     */
    interface DeleteDeviceResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteDevice()
     * @category deleteDevice()
     */
    interface DeleteDeviceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deleteDevice()
     * @category deleteDevice()
     */
    interface DeleteDeviceResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deleteDevice()
     * @category deleteDevice()
     */
    interface DeleteDeviceResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deleteDevice()
     * @category deleteDevice()
     */
    interface DeleteDeviceResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    type InstantiateDeviceParameters = {
        "device_id": string;
        "changedUrl"?: string;
    };
    /**
     * Typing for all possible responses to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    type InstantiateDeviceResponse = InstantiateDeviceSuccessResponse | InstantiateDeviceErrorResponse;
    /**
     * Typing for all successful responses to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    type InstantiateDeviceSuccessResponse = InstantiateDeviceResponse201;
    /**
     * Typing for all error responses to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    type InstantiateDeviceErrorResponse = InstantiateDeviceResponse400 | InstantiateDeviceResponse401 | InstantiateDeviceResponse403 | InstantiateDeviceResponse404 | InstantiateDeviceResponse500;
    /**
     * Typing for a response with status 201 to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    interface InstantiateDeviceResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: {
            instance: DeviceServiceTypes.ConcreteDevice<"response">;
            deviceToken: string;
            [k: string]: unknown;
        };
    }
    /**
     * Typing for a response with status 400 to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    interface InstantiateDeviceResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    interface InstantiateDeviceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    interface InstantiateDeviceResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    interface InstantiateDeviceResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by instantiateDevice()
     * @category instantiateDevice()
     */
    interface InstantiateDeviceResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    type GetDeviceAvailabilityParameters = {
        "device_id": string;
        "startTime"?: string;
        "endTime"?: string;
    };
    /**
     * Typing for all possible responses to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    type GetDeviceAvailabilityResponse = GetDeviceAvailabilitySuccessResponse | GetDeviceAvailabilityErrorResponse;
    /**
     * Typing for all successful responses to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    type GetDeviceAvailabilitySuccessResponse = GetDeviceAvailabilityResponse200;
    /**
     * Typing for all error responses to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    type GetDeviceAvailabilityErrorResponse = GetDeviceAvailabilityResponse400 | GetDeviceAvailabilityResponse401 | GetDeviceAvailabilityResponse403 | GetDeviceAvailabilityResponse404 | GetDeviceAvailabilityResponse500;
    /**
     * Typing for a response with status 200 to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    interface GetDeviceAvailabilityResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Availability<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    interface GetDeviceAvailabilityResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    interface GetDeviceAvailabilityResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    interface GetDeviceAvailabilityResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    interface GetDeviceAvailabilityResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getDeviceAvailability()
     * @category getDeviceAvailability()
     */
    interface GetDeviceAvailabilityResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    type DeleteDeviceAvailabilityRulesParameters = {
        "device_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    type DeleteDeviceAvailabilityRulesResponse = DeleteDeviceAvailabilityRulesSuccessResponse | DeleteDeviceAvailabilityRulesErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    type DeleteDeviceAvailabilityRulesSuccessResponse = DeleteDeviceAvailabilityRulesResponse204;
    /**
     * Typing for all error responses to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    type DeleteDeviceAvailabilityRulesErrorResponse = DeleteDeviceAvailabilityRulesResponse400 | DeleteDeviceAvailabilityRulesResponse401 | DeleteDeviceAvailabilityRulesResponse403 | DeleteDeviceAvailabilityRulesResponse404 | DeleteDeviceAvailabilityRulesResponse500;
    /**
     * Typing for a response with status 204 to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    interface DeleteDeviceAvailabilityRulesResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    interface DeleteDeviceAvailabilityRulesResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    interface DeleteDeviceAvailabilityRulesResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    interface DeleteDeviceAvailabilityRulesResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    interface DeleteDeviceAvailabilityRulesResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deleteDeviceAvailabilityRules()
     * @category deleteDeviceAvailabilityRules()
     */
    interface DeleteDeviceAvailabilityRulesResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    type AddDeviceAvailabilityRulesParameters = {
        "device_id": string;
    };
    /**
     * Typing for the body of the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    type AddDeviceAvailabilityRulesBody = (DeviceServiceTypes.AvailabilityRule<"request">)[] | undefined;
    /**
     * Typing for all possible responses to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    type AddDeviceAvailabilityRulesResponse = AddDeviceAvailabilityRulesSuccessResponse | AddDeviceAvailabilityRulesErrorResponse;
    /**
     * Typing for all successful responses to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    type AddDeviceAvailabilityRulesSuccessResponse = AddDeviceAvailabilityRulesResponse200;
    /**
     * Typing for all error responses to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    type AddDeviceAvailabilityRulesErrorResponse = AddDeviceAvailabilityRulesResponse400 | AddDeviceAvailabilityRulesResponse401 | AddDeviceAvailabilityRulesResponse403 | AddDeviceAvailabilityRulesResponse404 | AddDeviceAvailabilityRulesResponse500;
    /**
     * Typing for a response with status 200 to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    interface AddDeviceAvailabilityRulesResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Availability<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    interface AddDeviceAvailabilityRulesResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    interface AddDeviceAvailabilityRulesResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    interface AddDeviceAvailabilityRulesResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    interface AddDeviceAvailabilityRulesResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by addDeviceAvailabilityRules()
     * @category addDeviceAvailabilityRules()
     */
    interface AddDeviceAvailabilityRulesResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    type CreateWebsocketTokenParameters = {
        "device_id": string;
    };
    /**
     * Typing for all possible responses to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    type CreateWebsocketTokenResponse = CreateWebsocketTokenSuccessResponse | CreateWebsocketTokenErrorResponse;
    /**
     * Typing for all successful responses to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    type CreateWebsocketTokenSuccessResponse = CreateWebsocketTokenResponse200;
    /**
     * Typing for all error responses to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    type CreateWebsocketTokenErrorResponse = CreateWebsocketTokenResponse400 | CreateWebsocketTokenResponse401 | CreateWebsocketTokenResponse403 | CreateWebsocketTokenResponse404 | CreateWebsocketTokenResponse500;
    /**
     * Typing for a response with status 200 to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    interface CreateWebsocketTokenResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 400 to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    interface CreateWebsocketTokenResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    interface CreateWebsocketTokenResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    interface CreateWebsocketTokenResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    interface CreateWebsocketTokenResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by createWebsocketToken()
     * @category createWebsocketToken()
     */
    interface CreateWebsocketTokenResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    type SendSignalingMessageParameters = {
        "device_id": string;
    };
    /**
     * Typing for the body of the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    type SendSignalingMessageBody = DeviceServiceTypes.CreatePeerconnectionMessage<"request"> | DeviceServiceTypes.ClosePeerconnectionMessage<"request"> | DeviceServiceTypes.SignalingMessage<"request"> | DeviceServiceTypes.ConfigurationMessage<"request"> | DeviceServiceTypes.ExperimentStatusChangedMessage<"request"> | DeviceServiceTypes.LoggingMessage<"request">;
    /**
     * Typing for all possible responses to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    type SendSignalingMessageResponse = SendSignalingMessageSuccessResponse | SendSignalingMessageErrorResponse;
    /**
     * Typing for all successful responses to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    type SendSignalingMessageSuccessResponse = SendSignalingMessageResponse200;
    /**
     * Typing for all error responses to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    type SendSignalingMessageErrorResponse = SendSignalingMessageResponse400 | SendSignalingMessageResponse401 | SendSignalingMessageResponse403 | SendSignalingMessageResponse404 | SendSignalingMessageResponse500;
    /**
     * Typing for a response with status 200 to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    interface SendSignalingMessageResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    interface SendSignalingMessageResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    interface SendSignalingMessageResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    interface SendSignalingMessageResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    interface SendSignalingMessageResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by sendSignalingMessage()
     * @category sendSignalingMessage()
     */
    interface SendSignalingMessageResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for all possible responses to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    type ListPeerconnectionsResponse = ListPeerconnectionsSuccessResponse | ListPeerconnectionsErrorResponse;
    /**
     * Typing for all successful responses to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    type ListPeerconnectionsSuccessResponse = ListPeerconnectionsResponse200;
    /**
     * Typing for all error responses to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    type ListPeerconnectionsErrorResponse = ListPeerconnectionsResponse400 | ListPeerconnectionsResponse401 | ListPeerconnectionsResponse403 | ListPeerconnectionsResponse404 | ListPeerconnectionsResponse500;
    /**
     * Typing for a response with status 200 to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    interface ListPeerconnectionsResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (DeviceServiceTypes.PeerconnectionOverview<"response">)[];
    }
    /**
     * Typing for a response with status 400 to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    interface ListPeerconnectionsResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    interface ListPeerconnectionsResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    interface ListPeerconnectionsResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    interface ListPeerconnectionsResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by listPeerconnections()
     * @category listPeerconnections()
     */
    interface ListPeerconnectionsResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    type CreatePeerconnectionParameters = {
        "closedUrl"?: string;
        "statusChangedUrl"?: string;
    };
    /**
     * Typing for the body of the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    type CreatePeerconnectionBody = DeviceServiceTypes.Peerconnection<"request">;
    /**
     * Typing for all possible responses to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    type CreatePeerconnectionResponse = CreatePeerconnectionSuccessResponse | CreatePeerconnectionErrorResponse;
    /**
     * Typing for all successful responses to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    type CreatePeerconnectionSuccessResponse = CreatePeerconnectionResponse201 | CreatePeerconnectionResponse202;
    /**
     * Typing for all error responses to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    type CreatePeerconnectionErrorResponse = CreatePeerconnectionResponse400 | CreatePeerconnectionResponse401 | CreatePeerconnectionResponse403 | CreatePeerconnectionResponse404 | CreatePeerconnectionResponse500;
    /**
     * Typing for a response with status 201 to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    interface CreatePeerconnectionResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Peerconnection<"response">;
    }
    /**
     * Typing for a response with status 202 to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    interface CreatePeerconnectionResponse202 extends SuccessResponse {
        status: 202;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Peerconnection<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    interface CreatePeerconnectionResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    interface CreatePeerconnectionResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    interface CreatePeerconnectionResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    interface CreatePeerconnectionResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by createPeerconnection()
     * @category createPeerconnection()
     */
    interface CreatePeerconnectionResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    type GetPeerconnectionParameters = {
        "peerconnection_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    type GetPeerconnectionResponse = GetPeerconnectionSuccessResponse | GetPeerconnectionErrorResponse;
    /**
     * Typing for all successful responses to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    type GetPeerconnectionSuccessResponse = GetPeerconnectionResponse200;
    /**
     * Typing for all error responses to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    type GetPeerconnectionErrorResponse = GetPeerconnectionResponse400 | GetPeerconnectionResponse401 | GetPeerconnectionResponse403 | GetPeerconnectionResponse404 | GetPeerconnectionResponse500;
    /**
     * Typing for a response with status 200 to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    interface GetPeerconnectionResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: DeviceServiceTypes.Peerconnection<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    interface GetPeerconnectionResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    interface GetPeerconnectionResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    interface GetPeerconnectionResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    interface GetPeerconnectionResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getPeerconnection()
     * @category getPeerconnection()
     */
    interface GetPeerconnectionResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    type DeletePeerconnectionParameters = {
        "peerconnection_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    type DeletePeerconnectionResponse = DeletePeerconnectionSuccessResponse | DeletePeerconnectionErrorResponse;
    /**
     * Typing for all successful responses to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    type DeletePeerconnectionSuccessResponse = DeletePeerconnectionResponse202 | DeletePeerconnectionResponse204;
    /**
     * Typing for all error responses to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    type DeletePeerconnectionErrorResponse = DeletePeerconnectionResponse400 | DeletePeerconnectionResponse401 | DeletePeerconnectionResponse403 | DeletePeerconnectionResponse404 | DeletePeerconnectionResponse500;
    /**
     * Typing for a response with status 202 to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    interface DeletePeerconnectionResponse202 extends SuccessResponse {
        status: 202;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 204 to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    interface DeletePeerconnectionResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    interface DeletePeerconnectionResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    interface DeletePeerconnectionResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    interface DeletePeerconnectionResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    interface DeletePeerconnectionResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deletePeerconnection()
     * @category deletePeerconnection()
     */
    interface DeletePeerconnectionResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    type PatchPeerconnectionDeviceStatusParameters = {
        "peerconnection_id": string;
        "device_url": string;
    };
    /**
     * Typing for the body of the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    type PatchPeerconnectionDeviceStatusBody = {
        /**
         * The status of the peerconnection.
         */
        status: DeviceServiceTypes.ConnectionStatus<"request">;
        [k: string]: unknown;
    };
    /**
     * Typing for all possible responses to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    type PatchPeerconnectionDeviceStatusResponse = PatchPeerconnectionDeviceStatusSuccessResponse | PatchPeerconnectionDeviceStatusErrorResponse;
    /**
     * Typing for all successful responses to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    type PatchPeerconnectionDeviceStatusSuccessResponse = PatchPeerconnectionDeviceStatusResponse204;
    /**
     * Typing for all error responses to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    type PatchPeerconnectionDeviceStatusErrorResponse = PatchPeerconnectionDeviceStatusResponse400 | PatchPeerconnectionDeviceStatusResponse401 | PatchPeerconnectionDeviceStatusResponse403 | PatchPeerconnectionDeviceStatusResponse404 | PatchPeerconnectionDeviceStatusResponse500;
    /**
     * Typing for a response with status 204 to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    interface PatchPeerconnectionDeviceStatusResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    interface PatchPeerconnectionDeviceStatusResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    interface PatchPeerconnectionDeviceStatusResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    interface PatchPeerconnectionDeviceStatusResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    interface PatchPeerconnectionDeviceStatusResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by patchPeerconnectionDeviceStatus()
     * @category patchPeerconnectionDeviceStatus()
     */
    interface PatchPeerconnectionDeviceStatusResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
}
/**
 * Namespace containing the signatures for the Experiment Service.
 */
export declare namespace ExperimentServiceSignatures {
    /**
     * Typing for the parameters of the request made by listExperiments()
     * @category listExperiments()
     */
    type ListExperimentsParameters = {
        "experimentStatus"?: string;
    };
    /**
     * Typing for all possible responses to the request made by listExperiments()
     * @category listExperiments()
     */
    type ListExperimentsResponse = ListExperimentsSuccessResponse | ListExperimentsErrorResponse;
    /**
     * Typing for all successful responses to the request made by listExperiments()
     * @category listExperiments()
     */
    type ListExperimentsSuccessResponse = ListExperimentsResponse200;
    /**
     * Typing for all error responses to the request made by listExperiments()
     * @category listExperiments()
     */
    type ListExperimentsErrorResponse = ListExperimentsResponse400 | ListExperimentsResponse401 | ListExperimentsResponse403 | ListExperimentsResponse404 | ListExperimentsResponse500;
    /**
     * Typing for a response with status 200 to the request made by listExperiments()
     * @category listExperiments()
     */
    interface ListExperimentsResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (ExperimentServiceTypes.ExperimentOverview<"response">)[];
    }
    /**
     * Typing for a response with status 400 to the request made by listExperiments()
     * @category listExperiments()
     */
    interface ListExperimentsResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by listExperiments()
     * @category listExperiments()
     */
    interface ListExperimentsResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by listExperiments()
     * @category listExperiments()
     */
    interface ListExperimentsResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by listExperiments()
     * @category listExperiments()
     */
    interface ListExperimentsResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by listExperiments()
     * @category listExperiments()
     */
    interface ListExperimentsResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by createExperiment()
     * @category createExperiment()
     */
    type CreateExperimentParameters = {
        "changedURL"?: string;
    };
    /**
     * Typing for the body of the request made by createExperiment()
     * @category createExperiment()
     */
    type CreateExperimentBody = ExperimentServiceTypes.Experiment<"request">;
    /**
     * Typing for all possible responses to the request made by createExperiment()
     * @category createExperiment()
     */
    type CreateExperimentResponse = CreateExperimentSuccessResponse | CreateExperimentErrorResponse;
    /**
     * Typing for all successful responses to the request made by createExperiment()
     * @category createExperiment()
     */
    type CreateExperimentSuccessResponse = CreateExperimentResponse201 | CreateExperimentResponse202;
    /**
     * Typing for all error responses to the request made by createExperiment()
     * @category createExperiment()
     */
    type CreateExperimentErrorResponse = CreateExperimentResponse400 | CreateExperimentResponse401 | CreateExperimentResponse403 | CreateExperimentResponse404 | CreateExperimentResponse500;
    /**
     * Typing for a response with status 201 to the request made by createExperiment()
     * @category createExperiment()
     */
    interface CreateExperimentResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Experiment<"response">;
    }
    /**
     * Typing for a response with status 202 to the request made by createExperiment()
     * @category createExperiment()
     */
    interface CreateExperimentResponse202 extends SuccessResponse {
        status: 202;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Experiment<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by createExperiment()
     * @category createExperiment()
     */
    interface CreateExperimentResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by createExperiment()
     * @category createExperiment()
     */
    interface CreateExperimentResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by createExperiment()
     * @category createExperiment()
     */
    interface CreateExperimentResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by createExperiment()
     * @category createExperiment()
     */
    interface CreateExperimentResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by createExperiment()
     * @category createExperiment()
     */
    interface CreateExperimentResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getExperiment()
     * @category getExperiment()
     */
    type GetExperimentParameters = {
        "experiment_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getExperiment()
     * @category getExperiment()
     */
    type GetExperimentResponse = GetExperimentSuccessResponse | GetExperimentErrorResponse;
    /**
     * Typing for all successful responses to the request made by getExperiment()
     * @category getExperiment()
     */
    type GetExperimentSuccessResponse = GetExperimentResponse200;
    /**
     * Typing for all error responses to the request made by getExperiment()
     * @category getExperiment()
     */
    type GetExperimentErrorResponse = GetExperimentResponse400 | GetExperimentResponse401 | GetExperimentResponse403 | GetExperimentResponse404 | GetExperimentResponse500;
    /**
     * Typing for a response with status 200 to the request made by getExperiment()
     * @category getExperiment()
     */
    interface GetExperimentResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Experiment<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by getExperiment()
     * @category getExperiment()
     */
    interface GetExperimentResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getExperiment()
     * @category getExperiment()
     */
    interface GetExperimentResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getExperiment()
     * @category getExperiment()
     */
    interface GetExperimentResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getExperiment()
     * @category getExperiment()
     */
    interface GetExperimentResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getExperiment()
     * @category getExperiment()
     */
    interface GetExperimentResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateExperiment()
     * @category updateExperiment()
     */
    type UpdateExperimentParameters = {
        "experiment_id": string;
        "changedURL"?: string;
    };
    /**
     * Typing for the body of the request made by updateExperiment()
     * @category updateExperiment()
     */
    type UpdateExperimentBody = ExperimentServiceTypes.ExperimentUpdate<"request"> | undefined;
    /**
     * Typing for all possible responses to the request made by updateExperiment()
     * @category updateExperiment()
     */
    type UpdateExperimentResponse = UpdateExperimentSuccessResponse | UpdateExperimentErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateExperiment()
     * @category updateExperiment()
     */
    type UpdateExperimentSuccessResponse = UpdateExperimentResponse200 | UpdateExperimentResponse202;
    /**
     * Typing for all error responses to the request made by updateExperiment()
     * @category updateExperiment()
     */
    type UpdateExperimentErrorResponse = UpdateExperimentResponse400 | UpdateExperimentResponse401 | UpdateExperimentResponse403 | UpdateExperimentResponse404 | UpdateExperimentResponse500;
    /**
     * Typing for a response with status 200 to the request made by updateExperiment()
     * @category updateExperiment()
     */
    interface UpdateExperimentResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Experiment<"response">;
    }
    /**
     * Typing for a response with status 202 to the request made by updateExperiment()
     * @category updateExperiment()
     */
    interface UpdateExperimentResponse202 extends SuccessResponse {
        status: 202;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Experiment<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by updateExperiment()
     * @category updateExperiment()
     */
    interface UpdateExperimentResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updateExperiment()
     * @category updateExperiment()
     */
    interface UpdateExperimentResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by updateExperiment()
     * @category updateExperiment()
     */
    interface UpdateExperimentResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by updateExperiment()
     * @category updateExperiment()
     */
    interface UpdateExperimentResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by updateExperiment()
     * @category updateExperiment()
     */
    interface UpdateExperimentResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    type DeleteExperimentParameters = {
        "experiment_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    type DeleteExperimentResponse = DeleteExperimentSuccessResponse | DeleteExperimentErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    type DeleteExperimentSuccessResponse = DeleteExperimentResponse204;
    /**
     * Typing for all error responses to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    type DeleteExperimentErrorResponse = DeleteExperimentResponse400 | DeleteExperimentResponse401 | DeleteExperimentResponse403 | DeleteExperimentResponse404 | DeleteExperimentResponse500;
    /**
     * Typing for a response with status 204 to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    interface DeleteExperimentResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    interface DeleteExperimentResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    interface DeleteExperimentResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    interface DeleteExperimentResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    interface DeleteExperimentResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deleteExperiment()
     * @category deleteExperiment()
     */
    interface DeleteExperimentResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for all possible responses to the request made by listTemplate()
     * @category listTemplate()
     */
    type ListTemplateResponse = ListTemplateSuccessResponse | ListTemplateErrorResponse;
    /**
     * Typing for all successful responses to the request made by listTemplate()
     * @category listTemplate()
     */
    type ListTemplateSuccessResponse = ListTemplateResponse200;
    /**
     * Typing for all error responses to the request made by listTemplate()
     * @category listTemplate()
     */
    type ListTemplateErrorResponse = ListTemplateResponse400 | ListTemplateResponse401 | ListTemplateResponse403 | ListTemplateResponse404 | ListTemplateResponse500;
    /**
     * Typing for a response with status 200 to the request made by listTemplate()
     * @category listTemplate()
     */
    interface ListTemplateResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (ExperimentServiceTypes.TemplateOverview<"response">)[];
    }
    /**
     * Typing for a response with status 400 to the request made by listTemplate()
     * @category listTemplate()
     */
    interface ListTemplateResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by listTemplate()
     * @category listTemplate()
     */
    interface ListTemplateResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by listTemplate()
     * @category listTemplate()
     */
    interface ListTemplateResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by listTemplate()
     * @category listTemplate()
     */
    interface ListTemplateResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by listTemplate()
     * @category listTemplate()
     */
    interface ListTemplateResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the body of the request made by createTemplate()
     * @category createTemplate()
     */
    type CreateTemplateBody = ExperimentServiceTypes.Template<"request">;
    /**
     * Typing for all possible responses to the request made by createTemplate()
     * @category createTemplate()
     */
    type CreateTemplateResponse = CreateTemplateSuccessResponse | CreateTemplateErrorResponse;
    /**
     * Typing for all successful responses to the request made by createTemplate()
     * @category createTemplate()
     */
    type CreateTemplateSuccessResponse = CreateTemplateResponse201 | CreateTemplateResponse202;
    /**
     * Typing for all error responses to the request made by createTemplate()
     * @category createTemplate()
     */
    type CreateTemplateErrorResponse = CreateTemplateResponse400 | CreateTemplateResponse401 | CreateTemplateResponse403 | CreateTemplateResponse404 | CreateTemplateResponse500;
    /**
     * Typing for a response with status 201 to the request made by createTemplate()
     * @category createTemplate()
     */
    interface CreateTemplateResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Template<"response">;
    }
    /**
     * Typing for a response with status 202 to the request made by createTemplate()
     * @category createTemplate()
     */
    interface CreateTemplateResponse202 extends SuccessResponse {
        status: 202;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Template<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by createTemplate()
     * @category createTemplate()
     */
    interface CreateTemplateResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by createTemplate()
     * @category createTemplate()
     */
    interface CreateTemplateResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by createTemplate()
     * @category createTemplate()
     */
    interface CreateTemplateResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by createTemplate()
     * @category createTemplate()
     */
    interface CreateTemplateResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by createTemplate()
     * @category createTemplate()
     */
    interface CreateTemplateResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getTemplate()
     * @category getTemplate()
     */
    type GetTemplateParameters = {
        "template_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getTemplate()
     * @category getTemplate()
     */
    type GetTemplateResponse = GetTemplateSuccessResponse | GetTemplateErrorResponse;
    /**
     * Typing for all successful responses to the request made by getTemplate()
     * @category getTemplate()
     */
    type GetTemplateSuccessResponse = GetTemplateResponse200;
    /**
     * Typing for all error responses to the request made by getTemplate()
     * @category getTemplate()
     */
    type GetTemplateErrorResponse = GetTemplateResponse400 | GetTemplateResponse401 | GetTemplateResponse403 | GetTemplateResponse404 | GetTemplateResponse500;
    /**
     * Typing for a response with status 200 to the request made by getTemplate()
     * @category getTemplate()
     */
    interface GetTemplateResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Template<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by getTemplate()
     * @category getTemplate()
     */
    interface GetTemplateResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getTemplate()
     * @category getTemplate()
     */
    interface GetTemplateResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getTemplate()
     * @category getTemplate()
     */
    interface GetTemplateResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getTemplate()
     * @category getTemplate()
     */
    interface GetTemplateResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getTemplate()
     * @category getTemplate()
     */
    interface GetTemplateResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateTemplate()
     * @category updateTemplate()
     */
    type UpdateTemplateParameters = {
        "template_id": string;
    };
    /**
     * Typing for the body of the request made by updateTemplate()
     * @category updateTemplate()
     */
    type UpdateTemplateBody = ExperimentServiceTypes.TemplateUpdate<"request">;
    /**
     * Typing for all possible responses to the request made by updateTemplate()
     * @category updateTemplate()
     */
    type UpdateTemplateResponse = UpdateTemplateSuccessResponse | UpdateTemplateErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateTemplate()
     * @category updateTemplate()
     */
    type UpdateTemplateSuccessResponse = UpdateTemplateResponse200 | UpdateTemplateResponse202;
    /**
     * Typing for all error responses to the request made by updateTemplate()
     * @category updateTemplate()
     */
    type UpdateTemplateErrorResponse = UpdateTemplateResponse400 | UpdateTemplateResponse401 | UpdateTemplateResponse403 | UpdateTemplateResponse404 | UpdateTemplateResponse500;
    /**
     * Typing for a response with status 200 to the request made by updateTemplate()
     * @category updateTemplate()
     */
    interface UpdateTemplateResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Template<"response">;
    }
    /**
     * Typing for a response with status 202 to the request made by updateTemplate()
     * @category updateTemplate()
     */
    interface UpdateTemplateResponse202 extends SuccessResponse {
        status: 202;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ExperimentServiceTypes.Template<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by updateTemplate()
     * @category updateTemplate()
     */
    interface UpdateTemplateResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updateTemplate()
     * @category updateTemplate()
     */
    interface UpdateTemplateResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by updateTemplate()
     * @category updateTemplate()
     */
    interface UpdateTemplateResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by updateTemplate()
     * @category updateTemplate()
     */
    interface UpdateTemplateResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by updateTemplate()
     * @category updateTemplate()
     */
    interface UpdateTemplateResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    type DeleteTemplateParameters = {
        "template_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    type DeleteTemplateResponse = DeleteTemplateSuccessResponse | DeleteTemplateErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    type DeleteTemplateSuccessResponse = DeleteTemplateResponse204;
    /**
     * Typing for all error responses to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    type DeleteTemplateErrorResponse = DeleteTemplateResponse400 | DeleteTemplateResponse401 | DeleteTemplateResponse403 | DeleteTemplateResponse404 | DeleteTemplateResponse500;
    /**
     * Typing for a response with status 204 to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    interface DeleteTemplateResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    interface DeleteTemplateResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    interface DeleteTemplateResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    interface DeleteTemplateResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    interface DeleteTemplateResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deleteTemplate()
     * @category deleteTemplate()
     */
    interface DeleteTemplateResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
}
/**
 * Namespace containing the signatures for the Federation Service.
 */
export declare namespace FederationServiceSignatures {
    /**
     * Typing for all possible responses to the request made by listInstitutions()
     * @category listInstitutions()
     */
    type ListInstitutionsResponse = ListInstitutionsSuccessResponse | ListInstitutionsErrorResponse;
    /**
     * Typing for all successful responses to the request made by listInstitutions()
     * @category listInstitutions()
     */
    type ListInstitutionsSuccessResponse = ListInstitutionsResponse200;
    /**
     * Typing for all error responses to the request made by listInstitutions()
     * @category listInstitutions()
     */
    type ListInstitutionsErrorResponse = ListInstitutionsResponse400 | ListInstitutionsResponse401 | ListInstitutionsResponse403 | ListInstitutionsResponse404 | ListInstitutionsResponse500;
    /**
     * Typing for a response with status 200 to the request made by listInstitutions()
     * @category listInstitutions()
     */
    interface ListInstitutionsResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (FederationServiceTypes.Institution<"response">)[];
    }
    /**
     * Typing for a response with status 400 to the request made by listInstitutions()
     * @category listInstitutions()
     */
    interface ListInstitutionsResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by listInstitutions()
     * @category listInstitutions()
     */
    interface ListInstitutionsResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by listInstitutions()
     * @category listInstitutions()
     */
    interface ListInstitutionsResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by listInstitutions()
     * @category listInstitutions()
     */
    interface ListInstitutionsResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by listInstitutions()
     * @category listInstitutions()
     */
    interface ListInstitutionsResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the body of the request made by createInstitution()
     * @category createInstitution()
     */
    type CreateInstitutionBody = FederationServiceTypes.Institution<"request">;
    /**
     * Typing for all possible responses to the request made by createInstitution()
     * @category createInstitution()
     */
    type CreateInstitutionResponse = CreateInstitutionSuccessResponse | CreateInstitutionErrorResponse;
    /**
     * Typing for all successful responses to the request made by createInstitution()
     * @category createInstitution()
     */
    type CreateInstitutionSuccessResponse = CreateInstitutionResponse201;
    /**
     * Typing for all error responses to the request made by createInstitution()
     * @category createInstitution()
     */
    type CreateInstitutionErrorResponse = CreateInstitutionResponse400 | CreateInstitutionResponse401 | CreateInstitutionResponse403 | CreateInstitutionResponse404 | CreateInstitutionResponse500;
    /**
     * Typing for a response with status 201 to the request made by createInstitution()
     * @category createInstitution()
     */
    interface CreateInstitutionResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body: FederationServiceTypes.Institution<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by createInstitution()
     * @category createInstitution()
     */
    interface CreateInstitutionResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by createInstitution()
     * @category createInstitution()
     */
    interface CreateInstitutionResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by createInstitution()
     * @category createInstitution()
     */
    interface CreateInstitutionResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by createInstitution()
     * @category createInstitution()
     */
    interface CreateInstitutionResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by createInstitution()
     * @category createInstitution()
     */
    interface CreateInstitutionResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getInstitution()
     * @category getInstitution()
     */
    type GetInstitutionParameters = {
        "institution_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getInstitution()
     * @category getInstitution()
     */
    type GetInstitutionResponse = GetInstitutionSuccessResponse | GetInstitutionErrorResponse;
    /**
     * Typing for all successful responses to the request made by getInstitution()
     * @category getInstitution()
     */
    type GetInstitutionSuccessResponse = GetInstitutionResponse200;
    /**
     * Typing for all error responses to the request made by getInstitution()
     * @category getInstitution()
     */
    type GetInstitutionErrorResponse = GetInstitutionResponse400 | GetInstitutionResponse401 | GetInstitutionResponse403 | GetInstitutionResponse404 | GetInstitutionResponse500;
    /**
     * Typing for a response with status 200 to the request made by getInstitution()
     * @category getInstitution()
     */
    interface GetInstitutionResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: FederationServiceTypes.Institution<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by getInstitution()
     * @category getInstitution()
     */
    interface GetInstitutionResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by getInstitution()
     * @category getInstitution()
     */
    interface GetInstitutionResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getInstitution()
     * @category getInstitution()
     */
    interface GetInstitutionResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getInstitution()
     * @category getInstitution()
     */
    interface GetInstitutionResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getInstitution()
     * @category getInstitution()
     */
    interface GetInstitutionResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateInstitution()
     * @category updateInstitution()
     */
    type UpdateInstitutionParameters = {
        "institution_id": string;
    };
    /**
     * Typing for the body of the request made by updateInstitution()
     * @category updateInstitution()
     */
    type UpdateInstitutionBody = FederationServiceTypes.Institution<"request"> | undefined;
    /**
     * Typing for all possible responses to the request made by updateInstitution()
     * @category updateInstitution()
     */
    type UpdateInstitutionResponse = UpdateInstitutionSuccessResponse | UpdateInstitutionErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateInstitution()
     * @category updateInstitution()
     */
    type UpdateInstitutionSuccessResponse = UpdateInstitutionResponse200;
    /**
     * Typing for all error responses to the request made by updateInstitution()
     * @category updateInstitution()
     */
    type UpdateInstitutionErrorResponse = UpdateInstitutionResponse400 | UpdateInstitutionResponse401 | UpdateInstitutionResponse403 | UpdateInstitutionResponse404 | UpdateInstitutionResponse500;
    /**
     * Typing for a response with status 200 to the request made by updateInstitution()
     * @category updateInstitution()
     */
    interface UpdateInstitutionResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: FederationServiceTypes.Institution<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by updateInstitution()
     * @category updateInstitution()
     */
    interface UpdateInstitutionResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updateInstitution()
     * @category updateInstitution()
     */
    interface UpdateInstitutionResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by updateInstitution()
     * @category updateInstitution()
     */
    interface UpdateInstitutionResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by updateInstitution()
     * @category updateInstitution()
     */
    interface UpdateInstitutionResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by updateInstitution()
     * @category updateInstitution()
     */
    interface UpdateInstitutionResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    type DeleteInstitutionParameters = {
        "institution_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    type DeleteInstitutionResponse = DeleteInstitutionSuccessResponse | DeleteInstitutionErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    type DeleteInstitutionSuccessResponse = DeleteInstitutionResponse204;
    /**
     * Typing for all error responses to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    type DeleteInstitutionErrorResponse = DeleteInstitutionResponse400 | DeleteInstitutionResponse401 | DeleteInstitutionResponse403 | DeleteInstitutionResponse404 | DeleteInstitutionResponse500;
    /**
     * Typing for a response with status 204 to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    interface DeleteInstitutionResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 400 to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    interface DeleteInstitutionResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    interface DeleteInstitutionResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    interface DeleteInstitutionResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    interface DeleteInstitutionResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deleteInstitution()
     * @category deleteInstitution()
     */
    interface DeleteInstitutionResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
}
/**
 * Namespace containing the signatures for the Booking Service.
 */
export declare namespace BookingServiceSignatures {
    /**
     * Typing for the body of the request made by schedule()
     * @category schedule()
     */
    type ScheduleBody = {
        /**
         * An experiment describes a set of devices and how they should be connected (potentially among other metadata).
         */
        Experiment: BookingServiceTypes.Experiment<"request">;
        /**
         * A time slot represents a slice of time used for bookings.
         */
        Time: BookingServiceTypes.Timeslot<"request">;
        /**
         * If true, show only one timetable per device instead of one for all available physical devices.
         */
        Combined?: boolean;
        /**
         * (private) Show only devices of this institution. Give an error if a device of an other institution is requested.
         */
        onlyOwn?: boolean;
        [k: string]: unknown;
    } | undefined;
    /**
     * Typing for all possible responses to the request made by schedule()
     * @category schedule()
     */
    type ScheduleResponse = ScheduleSuccessResponse | ScheduleErrorResponse;
    /**
     * Typing for all successful responses to the request made by schedule()
     * @category schedule()
     */
    type ScheduleSuccessResponse = ScheduleResponse200;
    /**
     * Typing for all error responses to the request made by schedule()
     * @category schedule()
     */
    type ScheduleErrorResponse = ScheduleResponse400 | ScheduleResponse401 | ScheduleResponse403 | ScheduleResponse404 | ScheduleResponse422 | ScheduleResponse500 | ScheduleResponse503;
    /**
     * Typing for a response with status 200 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ({
            /**
             * ID of the device (or * if combined).
             */
            Device: string;
            /**
             * Array of booked times.
             */
            Booked: (BookingServiceTypes.Timeslot<"response">)[];
            /**
             * Array of free times.
             */
            Free: (BookingServiceTypes.Timeslot<"response">)[];
            [k: string]: unknown;
        })[];
    }
    /**
     * Typing for a response with status 400 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 422 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse422 extends ErrorResponse {
        status: 422;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 500 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by schedule()
     * @category schedule()
     */
    interface ScheduleResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the body of the request made by newBooking()
     * @category newBooking()
     */
    type NewBookingBody = {
        /**
         * List of devices which should be added.
         */
        Devices: (BookingServiceTypes.Device<"request">)[];
        /**
         * A time slot represents a slice of time used for bookings.
         */
        Time: BookingServiceTypes.Timeslot<"request">;
        /**
         * Type of booking. Currently, only one type is defined, but others might follow (e.g. priority booking). If empty, 'normal' is assumed.
         */
        Type?: "normal";
        [k: string]: unknown;
    };
    /**
     * Typing for all possible responses to the request made by newBooking()
     * @category newBooking()
     */
    type NewBookingResponse = NewBookingSuccessResponse | NewBookingErrorResponse;
    /**
     * Typing for all successful responses to the request made by newBooking()
     * @category newBooking()
     */
    type NewBookingSuccessResponse = NewBookingResponse200;
    /**
     * Typing for all error responses to the request made by newBooking()
     * @category newBooking()
     */
    type NewBookingErrorResponse = NewBookingResponse401 | NewBookingResponse403 | NewBookingResponse500 | NewBookingResponse503;
    /**
     * Typing for a response with status 200 to the request made by newBooking()
     * @category newBooking()
     */
    interface NewBookingResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: {
            /**
             * ID at which the booking can be managed.
             */
            BookingID: string;
            [k: string]: unknown;
        };
    }
    /**
     * Typing for a response with status 401 to the request made by newBooking()
     * @category newBooking()
     */
    interface NewBookingResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by newBooking()
     * @category newBooking()
     */
    interface NewBookingResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by newBooking()
     * @category newBooking()
     */
    interface NewBookingResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by newBooking()
     * @category newBooking()
     */
    interface NewBookingResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateBooking()
     * @category updateBooking()
     */
    type UpdateBookingParameters = {
        "ID": string;
    };
    /**
     * Typing for the body of the request made by updateBooking()
     * @category updateBooking()
     */
    type UpdateBookingBody = {
        /**
         * Expresses whether the devices should be locked. Must match current status of booking. Is assumed to be false if not set.
         */
        Locked?: boolean;
        /**
         * List of devices which should be added.
         */
        Devices?: (BookingServiceTypes.Device<"request">)[];
        [k: string]: unknown;
    } | {
        /**
         * Callback which should be called at changes.
         */
        Callback?: string;
        [k: string]: unknown;
    };
    /**
     * Typing for all possible responses to the request made by updateBooking()
     * @category updateBooking()
     */
    type UpdateBookingResponse = UpdateBookingSuccessResponse | UpdateBookingErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateBooking()
     * @category updateBooking()
     */
    type UpdateBookingSuccessResponse = UpdateBookingResponse200;
    /**
     * Typing for all error responses to the request made by updateBooking()
     * @category updateBooking()
     */
    type UpdateBookingErrorResponse = UpdateBookingResponse400 | UpdateBookingResponse401 | UpdateBookingResponse403 | UpdateBookingResponse404 | UpdateBookingResponse423 | UpdateBookingResponse500 | UpdateBookingResponse503;
    /**
     * Typing for a response with status 200 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: {
            BookingID: string;
            [k: string]: unknown;
        };
    }
    /**
     * Typing for a response with status 400 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 401 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 423 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse423 extends ErrorResponse {
        status: 423;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by updateBooking()
     * @category updateBooking()
     */
    interface UpdateBookingResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteBooking()
     * @category deleteBooking()
     */
    type DeleteBookingParameters = {
        "ID": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteBooking()
     * @category deleteBooking()
     */
    type DeleteBookingResponse = DeleteBookingSuccessResponse | DeleteBookingErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteBooking()
     * @category deleteBooking()
     */
    type DeleteBookingSuccessResponse = DeleteBookingResponse200;
    /**
     * Typing for all error responses to the request made by deleteBooking()
     * @category deleteBooking()
     */
    type DeleteBookingErrorResponse = DeleteBookingResponse401 | DeleteBookingResponse403 | DeleteBookingResponse404 | DeleteBookingResponse423 | DeleteBookingResponse500 | DeleteBookingResponse503;
    /**
     * Typing for a response with status 200 to the request made by deleteBooking()
     * @category deleteBooking()
     */
    interface DeleteBookingResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteBooking()
     * @category deleteBooking()
     */
    interface DeleteBookingResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by deleteBooking()
     * @category deleteBooking()
     */
    interface DeleteBookingResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by deleteBooking()
     * @category deleteBooking()
     */
    interface DeleteBookingResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 423 to the request made by deleteBooking()
     * @category deleteBooking()
     */
    interface DeleteBookingResponse423 extends ErrorResponse {
        status: 423;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by deleteBooking()
     * @category deleteBooking()
     */
    interface DeleteBookingResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by deleteBooking()
     * @category deleteBooking()
     */
    interface DeleteBookingResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getBooking()
     * @category getBooking()
     */
    type GetBookingParameters = {
        "ID": string;
    };
    /**
     * Typing for all possible responses to the request made by getBooking()
     * @category getBooking()
     */
    type GetBookingResponse = GetBookingSuccessResponse | GetBookingErrorResponse;
    /**
     * Typing for all successful responses to the request made by getBooking()
     * @category getBooking()
     */
    type GetBookingSuccessResponse = GetBookingResponse200;
    /**
     * Typing for all error responses to the request made by getBooking()
     * @category getBooking()
     */
    type GetBookingErrorResponse = GetBookingResponse401 | GetBookingResponse403 | GetBookingResponse404 | GetBookingResponse500 | GetBookingResponse503;
    /**
     * Typing for a response with status 200 to the request made by getBooking()
     * @category getBooking()
     */
    interface GetBookingResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: {
            /**
             * A booking in the booking system.
             */
            Booking: BookingServiceTypes.Booking<"response">;
            /**
             * Shows if the booking is in a locked status.
             */
            Locked: boolean;
            [k: string]: unknown;
        };
    }
    /**
     * Typing for a response with status 401 to the request made by getBooking()
     * @category getBooking()
     */
    interface GetBookingResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by getBooking()
     * @category getBooking()
     */
    interface GetBookingResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by getBooking()
     * @category getBooking()
     */
    interface GetBookingResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by getBooking()
     * @category getBooking()
     */
    interface GetBookingResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by getBooking()
     * @category getBooking()
     */
    interface GetBookingResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by destroyBooking()
     * @category destroyBooking()
     */
    type DestroyBookingParameters = {
        "ID": string;
    };
    /**
     * Typing for all possible responses to the request made by destroyBooking()
     * @category destroyBooking()
     */
    type DestroyBookingResponse = DestroyBookingSuccessResponse | DestroyBookingErrorResponse;
    /**
     * Typing for all successful responses to the request made by destroyBooking()
     * @category destroyBooking()
     */
    type DestroyBookingSuccessResponse = DestroyBookingResponse200;
    /**
     * Typing for all error responses to the request made by destroyBooking()
     * @category destroyBooking()
     */
    type DestroyBookingErrorResponse = DestroyBookingResponse401 | DestroyBookingResponse403 | DestroyBookingResponse404 | DestroyBookingResponse423 | DestroyBookingResponse500 | DestroyBookingResponse503;
    /**
     * Typing for a response with status 200 to the request made by destroyBooking()
     * @category destroyBooking()
     */
    interface DestroyBookingResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by destroyBooking()
     * @category destroyBooking()
     */
    interface DestroyBookingResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by destroyBooking()
     * @category destroyBooking()
     */
    interface DestroyBookingResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by destroyBooking()
     * @category destroyBooking()
     */
    interface DestroyBookingResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 423 to the request made by destroyBooking()
     * @category destroyBooking()
     */
    interface DestroyBookingResponse423 extends ErrorResponse {
        status: 423;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by destroyBooking()
     * @category destroyBooking()
     */
    interface DestroyBookingResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by destroyBooking()
     * @category destroyBooking()
     */
    interface DestroyBookingResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by lockBooking()
     * @category lockBooking()
     */
    type LockBookingParameters = {
        "ID": string;
    };
    /**
     * Typing for all possible responses to the request made by lockBooking()
     * @category lockBooking()
     */
    type LockBookingResponse = LockBookingSuccessResponse | LockBookingErrorResponse;
    /**
     * Typing for all successful responses to the request made by lockBooking()
     * @category lockBooking()
     */
    type LockBookingSuccessResponse = LockBookingResponse200;
    /**
     * Typing for all error responses to the request made by lockBooking()
     * @category lockBooking()
     */
    type LockBookingErrorResponse = LockBookingResponse401 | LockBookingResponse403 | LockBookingResponse404 | LockBookingResponse412 | LockBookingResponse500 | LockBookingResponse503;
    /**
     * Typing for a response with status 200 to the request made by lockBooking()
     * @category lockBooking()
     */
    interface LockBookingResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: ({
            Requested: string;
            Selected: string;
            [k: string]: unknown;
        })[];
    }
    /**
     * Typing for a response with status 401 to the request made by lockBooking()
     * @category lockBooking()
     */
    interface LockBookingResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by lockBooking()
     * @category lockBooking()
     */
    interface LockBookingResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by lockBooking()
     * @category lockBooking()
     */
    interface LockBookingResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 412 to the request made by lockBooking()
     * @category lockBooking()
     */
    interface LockBookingResponse412 extends ErrorResponse {
        status: 412;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by lockBooking()
     * @category lockBooking()
     */
    interface LockBookingResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by lockBooking()
     * @category lockBooking()
     */
    interface LockBookingResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by unlockBooking()
     * @category unlockBooking()
     */
    type UnlockBookingParameters = {
        "ID": string;
    };
    /**
     * Typing for all possible responses to the request made by unlockBooking()
     * @category unlockBooking()
     */
    type UnlockBookingResponse = UnlockBookingSuccessResponse | UnlockBookingErrorResponse;
    /**
     * Typing for all successful responses to the request made by unlockBooking()
     * @category unlockBooking()
     */
    type UnlockBookingSuccessResponse = UnlockBookingResponse200;
    /**
     * Typing for all error responses to the request made by unlockBooking()
     * @category unlockBooking()
     */
    type UnlockBookingErrorResponse = UnlockBookingResponse401 | UnlockBookingResponse403 | UnlockBookingResponse404 | UnlockBookingResponse412 | UnlockBookingResponse500 | UnlockBookingResponse503;
    /**
     * Typing for a response with status 200 to the request made by unlockBooking()
     * @category unlockBooking()
     */
    interface UnlockBookingResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by unlockBooking()
     * @category unlockBooking()
     */
    interface UnlockBookingResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 403 to the request made by unlockBooking()
     * @category unlockBooking()
     */
    interface UnlockBookingResponse403 extends ErrorResponse {
        status: 403;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by unlockBooking()
     * @category unlockBooking()
     */
    interface UnlockBookingResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 412 to the request made by unlockBooking()
     * @category unlockBooking()
     */
    interface UnlockBookingResponse412 extends ErrorResponse {
        status: 412;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by unlockBooking()
     * @category unlockBooking()
     */
    interface UnlockBookingResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by unlockBooking()
     * @category unlockBooking()
     */
    interface UnlockBookingResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by bookingCallback()
     * @category bookingCallback()
     */
    type BookingCallbackParameters = {
        "ID": string;
    };
    /**
     * Typing for all possible responses to the request made by bookingCallback()
     * @category bookingCallback()
     */
    type BookingCallbackResponse = BookingCallbackSuccessResponse | BookingCallbackErrorResponse;
    /**
     * Typing for all successful responses to the request made by bookingCallback()
     * @category bookingCallback()
     */
    type BookingCallbackSuccessResponse = BookingCallbackResponse200;
    /**
     * Typing for all error responses to the request made by bookingCallback()
     * @category bookingCallback()
     */
    type BookingCallbackErrorResponse = BookingCallbackResponse404 | BookingCallbackResponse500 | BookingCallbackResponse503;
    /**
     * Typing for a response with status 200 to the request made by bookingCallback()
     * @category bookingCallback()
     */
    interface BookingCallbackResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 404 to the request made by bookingCallback()
     * @category bookingCallback()
     */
    interface BookingCallbackResponse404 extends ErrorResponse {
        status: 404;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 500 to the request made by bookingCallback()
     * @category bookingCallback()
     */
    interface BookingCallbackResponse500 extends ErrorResponse {
        status: 500;
        headers?: {
            [k: string]: string | undefined;
        };
        body: string;
    }
    /**
     * Typing for a response with status 503 to the request made by bookingCallback()
     * @category bookingCallback()
     */
    interface BookingCallbackResponse503 extends ErrorResponse {
        status: 503;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
}
/**
 * Namespace containing the signatures for the LTI Service.
 */
export declare namespace LTIServiceSignatures {
    /**
     * Typing for all possible responses to the request made by listPlatform()
     * @category listPlatform()
     */
    type ListPlatformResponse = ListPlatformSuccessResponse | ListPlatformErrorResponse;
    /**
     * Typing for all successful responses to the request made by listPlatform()
     * @category listPlatform()
     */
    type ListPlatformSuccessResponse = ListPlatformResponse200;
    /**
     * Typing for all error responses to the request made by listPlatform()
     * @category listPlatform()
     */
    type ListPlatformErrorResponse = ListPlatformResponse401;
    /**
     * Typing for a response with status 200 to the request made by listPlatform()
     * @category listPlatform()
     */
    interface ListPlatformResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (LTIServiceTypes.Platform<"response">)[];
    }
    /**
     * Typing for a response with status 401 to the request made by listPlatform()
     * @category listPlatform()
     */
    interface ListPlatformResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for all possible responses to the request made by registerPlatform()
     * @category registerPlatform()
     */
    type RegisterPlatformResponse = RegisterPlatformSuccessResponse | RegisterPlatformErrorResponse;
    /**
     * Typing for all successful responses to the request made by registerPlatform()
     * @category registerPlatform()
     */
    type RegisterPlatformSuccessResponse = RegisterPlatformResponse201;
    /**
     * Typing for all error responses to the request made by registerPlatform()
     * @category registerPlatform()
     */
    type RegisterPlatformErrorResponse = RegisterPlatformResponse401;
    /**
     * Typing for a response with status 201 to the request made by registerPlatform()
     * @category registerPlatform()
     */
    interface RegisterPlatformResponse201 extends SuccessResponse {
        status: 201;
        headers: {
            "Location"?: string;
            [k: string]: string | undefined;
        };
        body: LTIServiceTypes.Platform<"response">;
    }
    /**
     * Typing for a response with status 401 to the request made by registerPlatform()
     * @category registerPlatform()
     */
    interface RegisterPlatformResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getPlatform()
     * @category getPlatform()
     */
    type GetPlatformParameters = {
        "platform_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getPlatform()
     * @category getPlatform()
     */
    type GetPlatformResponse = GetPlatformSuccessResponse | GetPlatformErrorResponse;
    /**
     * Typing for all successful responses to the request made by getPlatform()
     * @category getPlatform()
     */
    type GetPlatformSuccessResponse = GetPlatformResponse200;
    /**
     * Typing for all error responses to the request made by getPlatform()
     * @category getPlatform()
     */
    type GetPlatformErrorResponse = GetPlatformResponse401;
    /**
     * Typing for a response with status 200 to the request made by getPlatform()
     * @category getPlatform()
     */
    interface GetPlatformResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: LTIServiceTypes.Platform<"response">;
    }
    /**
     * Typing for a response with status 401 to the request made by getPlatform()
     * @category getPlatform()
     */
    interface GetPlatformResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updatePlatform()
     * @category updatePlatform()
     */
    type UpdatePlatformParameters = {
        "platform_id": string;
    };
    /**
     * Typing for all possible responses to the request made by updatePlatform()
     * @category updatePlatform()
     */
    type UpdatePlatformResponse = UpdatePlatformSuccessResponse | UpdatePlatformErrorResponse;
    /**
     * Typing for all successful responses to the request made by updatePlatform()
     * @category updatePlatform()
     */
    type UpdatePlatformSuccessResponse = UpdatePlatformResponse200;
    /**
     * Typing for all error responses to the request made by updatePlatform()
     * @category updatePlatform()
     */
    type UpdatePlatformErrorResponse = UpdatePlatformResponse400 | UpdatePlatformResponse401;
    /**
     * Typing for a response with status 200 to the request made by updatePlatform()
     * @category updatePlatform()
     */
    interface UpdatePlatformResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: LTIServiceTypes.Platform<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by updatePlatform()
     * @category updatePlatform()
     */
    interface UpdatePlatformResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updatePlatform()
     * @category updatePlatform()
     */
    interface UpdatePlatformResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deletePlatform()
     * @category deletePlatform()
     */
    type DeletePlatformParameters = {
        "platform_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deletePlatform()
     * @category deletePlatform()
     */
    type DeletePlatformResponse = DeletePlatformSuccessResponse | DeletePlatformErrorResponse;
    /**
     * Typing for all successful responses to the request made by deletePlatform()
     * @category deletePlatform()
     */
    type DeletePlatformSuccessResponse = DeletePlatformResponse204;
    /**
     * Typing for all error responses to the request made by deletePlatform()
     * @category deletePlatform()
     */
    type DeletePlatformErrorResponse = DeletePlatformResponse401;
    /**
     * Typing for a response with status 204 to the request made by deletePlatform()
     * @category deletePlatform()
     */
    interface DeletePlatformResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deletePlatform()
     * @category deletePlatform()
     */
    interface DeletePlatformResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by ltiLogin()
     * @category ltiLogin()
     */
    type LtiLoginParameters = {
        "platform_id": string;
    };
    /**
     * Typing for the body of the request made by ltiLogin()
     * @category ltiLogin()
     */
    type LtiLoginBody = {
        /**
         * The issuer of the LTI message.
         */
        iss: string;
        /**
         * The client ID of the LTI message.
         */
        client_id: string;
        /**
         * The deployment ID of the LTI message.
         */
        lti_deployment_id?: string;
        /**
         * The target link URI of the LTI message.
         */
        target_link_uri: string;
        /**
         * The login hint of the LTI message.
         */
        login_hint: string;
        /**
         * The LTI message hint of the LTI message.
         */
        lti_message_hint: string;
    };
    /**
     * Typing for all possible responses to the request made by ltiLogin()
     * @category ltiLogin()
     */
    type LtiLoginResponse = LtiLoginSuccessResponse;
    /**
     * Typing for all successful responses to the request made by ltiLogin()
     * @category ltiLogin()
     */
    type LtiLoginSuccessResponse = LtiLoginResponse200;
    /**
     * Typing for a response with status 200 to the request made by ltiLogin()
     * @category ltiLogin()
     */
    interface LtiLoginResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: {
            /**
             * The authentication request URL. The Frontend should send a 302 redirect of this URL to the user agent.
             */
            authentication_request_url: string;
        };
    }
    /**
     * Typing for the parameters of the request made by ltiLaunch()
     * @category ltiLaunch()
     */
    type LtiLaunchParameters = {
        "platform_id": string;
    };
    /**
     * Typing for the body of the request made by ltiLaunch()
     * @category ltiLaunch()
     */
    type LtiLaunchBody = {
        /**
         * The state of the LTI message.
         */
        state: string;
        /**
         * The ID token of the LTI message.
         */
        id_token: string;
    };
    /**
     * Typing for all possible responses to the request made by ltiLaunch()
     * @category ltiLaunch()
     */
    type LtiLaunchResponse = LtiLaunchSuccessResponse;
    /**
     * Typing for all successful responses to the request made by ltiLaunch()
     * @category ltiLaunch()
     */
    type LtiLaunchSuccessResponse = LtiLaunchResponse200;
    /**
     * Typing for a response with status 200 to the request made by ltiLaunch()
     * @category ltiLaunch()
     */
    interface LtiLaunchResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: {
            /**
             * The access token to authenticate subsequent requests.
             */
            access_token: string;
            session: LTIServiceTypes.Session<"response">;
            [k: string]: unknown;
        };
    }
    /**
     * Typing for the parameters of the request made by ltiJwks()
     * @category ltiJwks()
     */
    type LtiJwksParameters = {
        "platform_id": string;
    };
    /**
     * Typing for all possible responses to the request made by ltiJwks()
     * @category ltiJwks()
     */
    type LtiJwksResponse = LtiJwksSuccessResponse;
    /**
     * Typing for all successful responses to the request made by ltiJwks()
     * @category ltiJwks()
     */
    type LtiJwksSuccessResponse = LtiJwksResponse200;
    /**
     * Typing for a response with status 200 to the request made by ltiJwks()
     * @category ltiJwks()
     */
    interface LtiJwksResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: {
            [k: string]: unknown;
        };
    }
    /**
     * Typing for all possible responses to the request made by listResource()
     * @category listResource()
     */
    type ListResourceResponse = ListResourceSuccessResponse | ListResourceErrorResponse;
    /**
     * Typing for all successful responses to the request made by listResource()
     * @category listResource()
     */
    type ListResourceSuccessResponse = ListResourceResponse200;
    /**
     * Typing for all error responses to the request made by listResource()
     * @category listResource()
     */
    type ListResourceErrorResponse = ListResourceResponse401;
    /**
     * Typing for a response with status 200 to the request made by listResource()
     * @category listResource()
     */
    interface ListResourceResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (LTIServiceTypes.Resource<"response">)[];
    }
    /**
     * Typing for a response with status 401 to the request made by listResource()
     * @category listResource()
     */
    interface ListResourceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getResource()
     * @category getResource()
     */
    type GetResourceParameters = {
        "resource_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getResource()
     * @category getResource()
     */
    type GetResourceResponse = GetResourceSuccessResponse | GetResourceErrorResponse;
    /**
     * Typing for all successful responses to the request made by getResource()
     * @category getResource()
     */
    type GetResourceSuccessResponse = GetResourceResponse200;
    /**
     * Typing for all error responses to the request made by getResource()
     * @category getResource()
     */
    type GetResourceErrorResponse = GetResourceResponse401;
    /**
     * Typing for a response with status 200 to the request made by getResource()
     * @category getResource()
     */
    interface GetResourceResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: LTIServiceTypes.Resource<"response">;
    }
    /**
     * Typing for a response with status 401 to the request made by getResource()
     * @category getResource()
     */
    interface GetResourceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateResource()
     * @category updateResource()
     */
    type UpdateResourceParameters = {
        "resource_id": string;
    };
    /**
     * Typing for the body of the request made by updateResource()
     * @category updateResource()
     */
    type UpdateResourceBody = {
        uri?: string;
        /**
         * The URI of the experiment template.
         */
        experiment_template_uri?: string;
        /**
         * The URI of the students.
         */
        students_uri?: string;
    };
    /**
     * Typing for all possible responses to the request made by updateResource()
     * @category updateResource()
     */
    type UpdateResourceResponse = UpdateResourceSuccessResponse | UpdateResourceErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateResource()
     * @category updateResource()
     */
    type UpdateResourceSuccessResponse = UpdateResourceResponse200;
    /**
     * Typing for all error responses to the request made by updateResource()
     * @category updateResource()
     */
    type UpdateResourceErrorResponse = UpdateResourceResponse400 | UpdateResourceResponse401;
    /**
     * Typing for a response with status 200 to the request made by updateResource()
     * @category updateResource()
     */
    interface UpdateResourceResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: LTIServiceTypes.Resource<"response">;
    }
    /**
     * Typing for a response with status 400 to the request made by updateResource()
     * @category updateResource()
     */
    interface UpdateResourceResponse400 extends ErrorResponse {
        status: 400;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by updateResource()
     * @category updateResource()
     */
    interface UpdateResourceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by deleteResource()
     * @category deleteResource()
     */
    type DeleteResourceParameters = {
        "resource_id": string;
    };
    /**
     * Typing for all possible responses to the request made by deleteResource()
     * @category deleteResource()
     */
    type DeleteResourceResponse = DeleteResourceSuccessResponse | DeleteResourceErrorResponse;
    /**
     * Typing for all successful responses to the request made by deleteResource()
     * @category deleteResource()
     */
    type DeleteResourceSuccessResponse = DeleteResourceResponse204;
    /**
     * Typing for all error responses to the request made by deleteResource()
     * @category deleteResource()
     */
    type DeleteResourceErrorResponse = DeleteResourceResponse401;
    /**
     * Typing for a response with status 204 to the request made by deleteResource()
     * @category deleteResource()
     */
    interface DeleteResourceResponse204 extends SuccessResponse {
        status: 204;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for a response with status 401 to the request made by deleteResource()
     * @category deleteResource()
     */
    interface DeleteResourceResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by listResourceStudents()
     * @category listResourceStudents()
     */
    type ListResourceStudentsParameters = {
        "resource_id": string;
    };
    /**
     * Typing for all possible responses to the request made by listResourceStudents()
     * @category listResourceStudents()
     */
    type ListResourceStudentsResponse = ListResourceStudentsSuccessResponse | ListResourceStudentsErrorResponse;
    /**
     * Typing for all successful responses to the request made by listResourceStudents()
     * @category listResourceStudents()
     */
    type ListResourceStudentsSuccessResponse = ListResourceStudentsResponse200;
    /**
     * Typing for all error responses to the request made by listResourceStudents()
     * @category listResourceStudents()
     */
    type ListResourceStudentsErrorResponse = ListResourceStudentsResponse401;
    /**
     * Typing for a response with status 200 to the request made by listResourceStudents()
     * @category listResourceStudents()
     */
    interface ListResourceStudentsResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (LTIServiceTypes.Student<"response">)[];
    }
    /**
     * Typing for a response with status 401 to the request made by listResourceStudents()
     * @category listResourceStudents()
     */
    interface ListResourceStudentsResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateResourceStudents()
     * @category updateResourceStudents()
     */
    type UpdateResourceStudentsParameters = {
        "resource_id": string;
    };
    /**
     * Typing for the body of the request made by updateResourceStudents()
     * @category updateResourceStudents()
     */
    type UpdateResourceStudentsBody = ({
        uri: string;
        data: LTIServiceTypes.Student<"request">;
        [k: string]: unknown;
    })[];
    /**
     * Typing for all possible responses to the request made by updateResourceStudents()
     * @category updateResourceStudents()
     */
    type UpdateResourceStudentsResponse = UpdateResourceStudentsSuccessResponse | UpdateResourceStudentsErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateResourceStudents()
     * @category updateResourceStudents()
     */
    type UpdateResourceStudentsSuccessResponse = UpdateResourceStudentsResponse200;
    /**
     * Typing for all error responses to the request made by updateResourceStudents()
     * @category updateResourceStudents()
     */
    type UpdateResourceStudentsErrorResponse = UpdateResourceStudentsResponse401;
    /**
     * Typing for a response with status 200 to the request made by updateResourceStudents()
     * @category updateResourceStudents()
     */
    interface UpdateResourceStudentsResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: (LTIServiceTypes.Student<"response">)[];
    }
    /**
     * Typing for a response with status 401 to the request made by updateResourceStudents()
     * @category updateResourceStudents()
     */
    interface UpdateResourceStudentsResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by getResourceStudent()
     * @category getResourceStudent()
     */
    type GetResourceStudentParameters = {
        "resource_id": string;
        "student_id": string;
    };
    /**
     * Typing for all possible responses to the request made by getResourceStudent()
     * @category getResourceStudent()
     */
    type GetResourceStudentResponse = GetResourceStudentSuccessResponse | GetResourceStudentErrorResponse;
    /**
     * Typing for all successful responses to the request made by getResourceStudent()
     * @category getResourceStudent()
     */
    type GetResourceStudentSuccessResponse = GetResourceStudentResponse200;
    /**
     * Typing for all error responses to the request made by getResourceStudent()
     * @category getResourceStudent()
     */
    type GetResourceStudentErrorResponse = GetResourceStudentResponse401;
    /**
     * Typing for a response with status 200 to the request made by getResourceStudent()
     * @category getResourceStudent()
     */
    interface GetResourceStudentResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: LTIServiceTypes.Student<"response">;
    }
    /**
     * Typing for a response with status 401 to the request made by getResourceStudent()
     * @category getResourceStudent()
     */
    interface GetResourceStudentResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateResourceStudent()
     * @category updateResourceStudent()
     */
    type UpdateResourceStudentParameters = {
        "resource_id": string;
        "student_id": string;
    };
    /**
     * Typing for the body of the request made by updateResourceStudent()
     * @category updateResourceStudent()
     */
    type UpdateResourceStudentBody = LTIServiceTypes.Student<"request">;
    /**
     * Typing for all possible responses to the request made by updateResourceStudent()
     * @category updateResourceStudent()
     */
    type UpdateResourceStudentResponse = UpdateResourceStudentSuccessResponse | UpdateResourceStudentErrorResponse;
    /**
     * Typing for all successful responses to the request made by updateResourceStudent()
     * @category updateResourceStudent()
     */
    type UpdateResourceStudentSuccessResponse = UpdateResourceStudentResponse200;
    /**
     * Typing for all error responses to the request made by updateResourceStudent()
     * @category updateResourceStudent()
     */
    type UpdateResourceStudentErrorResponse = UpdateResourceStudentResponse401;
    /**
     * Typing for a response with status 200 to the request made by updateResourceStudent()
     * @category updateResourceStudent()
     */
    interface UpdateResourceStudentResponse200 extends SuccessResponse {
        status: 200;
        headers?: {
            [k: string]: string | undefined;
        };
        body: LTIServiceTypes.Student<"response">;
    }
    /**
     * Typing for a response with status 401 to the request made by updateResourceStudent()
     * @category updateResourceStudent()
     */
    interface UpdateResourceStudentResponse401 extends ErrorResponse {
        status: 401;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
    /**
     * Typing for the parameters of the request made by updateLtiExperiment()
     * @category updateLtiExperiment()
     */
    type UpdateLtiExperimentParameters = {
        "session_id": string;
    };
    /**
     * Typing for the body of the request made by updateLtiExperiment()
     * @category updateLtiExperiment()
     */
    type UpdateLtiExperimentBody = {
        /**
         * URI of the student to impersonate.
         */
        impersonate?: string;
        /**
         * Mapping of roles to devices.
         * This overwrites any existing role mapping possibles et by the student impersonation.
         */
        role_mapping?: ({
            role: string;
            device: "GROUP" | string;
            [k: string]: unknown;
        })[];
        [k: string]: unknown;
    };
    /**
     * Typing for all possible responses to the request made by updateLtiExperiment()
     * @category updateLtiExperiment()
     */
    type UpdateLtiExperimentResponse = UpdateLtiExperimentSuccessResponse;
    /**
     * Typing for all successful responses to the request made by updateLtiExperiment()
     * @category updateLtiExperiment()
     */
    type UpdateLtiExperimentSuccessResponse = UpdateLtiExperimentResponse201;
    /**
     * Typing for a response with status 201 to the request made by updateLtiExperiment()
     * @category updateLtiExperiment()
     */
    interface UpdateLtiExperimentResponse201 extends SuccessResponse {
        status: 201;
        headers?: {
            [k: string]: string | undefined;
        };
        body?: undefined;
    }
}
//# sourceMappingURL=signatures.d.ts.map